searchNodes=[{"doc":"Holds the Sippet stack. Network transport protocols should be registered during initialization: def init(_) do Sippet.register_transport(:udp, false) ... end Messages are dispatched to transports by sending the following message: send(pid, {:send_message, message, host, port, transaction}) Whenever a message is received by a transport, the function Sippet.handle_transport_message is called, which will validate and route messages through the transaction layer or send directly to the core.","ref":"Sippet.html","title":"Sippet","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"Sippet.html#child_spec/1","title":"Sippet.child_spec/1","type":"function"},{"doc":"Registers the stack core.","ref":"Sippet.html#register_core/2","title":"Sippet.register_core/2","type":"function"},{"doc":"Registers a transport for a given protocol.","ref":"Sippet.html#register_transport/3","title":"Sippet.register_transport/3","type":"function"},{"doc":"Verifies if the transport protocol used to send the given message is reliable.","ref":"Sippet.html#reliable?/2","title":"Sippet.reliable?/2","type":"function"},{"doc":"Sends a message (request or response) using transactions if possible. Requests of method :ack is sent directly to the transport layer. A Sippet.Transactions.Client is created for requests to handle client retransmissions, when the transport presumes it, and match response retransmissions, so the Sippet.Core doesn&#39;t get retransmissions other than 200 OK for :invite requests. In case of success, returns :ok.","ref":"Sippet.html#send/2","title":"Sippet.send/2","type":"function"},{"doc":"Handles the sigil ~K. It returns a client or server transaction key depending on the number of parameters passed. Examples iex&gt; import Sippet, only: [sigil_K: 2] iex&gt; Sippet.Transactions.Client.Key.new(&quot;z9hG4bK230f2.1&quot;, :invite) ~K[z9hG4bK230f2.1|:invite] iex&gt; ~K[z9hG4bK230f2.1|INVITE] ~K[z9hG4bK230f2.1|:invite] iex&gt; Sippet.Transactions.Server.Key.new(&quot;z9hG4bK74b21&quot;, :invite, {&quot;client.biloxi.example.com&quot;, 5060}) ~K[z9hG4bK74b21|:invite|client.biloxi.example.com:5060] iex&gt; ~K[z9hG4bK74b21|INVITE|client.biloxi.example.com:5060] ~K[z9hG4bK74b21|:invite|client.biloxi.example.com:5060]","ref":"Sippet.html#sigil_K/2","title":"Sippet.sigil_K/2","type":"function"},{"doc":"Terminates a client or server transaction forcefully. This function is not generally executed by entities; there is a single case where it is fundamental, which is when a client transaction is in proceeding state for a long time, and the transaction has to be finished forcibly, or it will never finish by itself. If a transaction with such a key does not exist, it will be silently ignored.","ref":"Sippet.html#terminate/2","title":"Sippet.terminate/2","type":"function"},{"doc":"A client transaction identifier","ref":"Sippet.html#t:client_key/0","title":"Sippet.client_key/0","type":"type"},{"doc":"An network error that occurred while sending a message","ref":"Sippet.html#t:reason/0","title":"Sippet.reason/0","type":"type"},{"doc":"A SIP message request","ref":"Sippet.html#t:request/0","title":"Sippet.request/0","type":"type"},{"doc":"A SIP message response","ref":"Sippet.html#t:response/0","title":"Sippet.response/0","type":"type"},{"doc":"A server transaction identifier","ref":"Sippet.html#t:server_key/0","title":"Sippet.server_key/0","type":"type"},{"doc":"Sippet identifier","ref":"Sippet.html#t:sippet/0","title":"Sippet.sippet/0","type":"type"},{"doc":"A behaviour module for implementing the Sippet.Core. The Sippet.Core designates a particular type of SIP entity, i.e., specific to either a stateful or stateless proxy, a user agent or registrar.","ref":"Sippet.Core.html","title":"Sippet.Core","type":"behaviour"},{"doc":"Receives an error from the server or client transaction. The function receive_error/2 is called from the client or server transaction process created when sending or receiving requests.","ref":"Sippet.Core.html#c:receive_error/2","title":"Sippet.Core.receive_error/2","type":"callback"},{"doc":"Receives a new incoming request from a remote host, or ACK. The server_key indicates the name of the transaction created when the request was received. If it is an ACK, then the server_key is nil. The function receive_request/2 is called from the server transaction process when the parameter server_key is not nil, and from the transport process (possibly a poolboy worker process), when the server_key is nil.","ref":"Sippet.Core.html#c:receive_request/2","title":"Sippet.Core.receive_request/2","type":"callback"},{"doc":"Receives a response for a sent request. The client_key indicates the name of the transaction created when the request was sent using Sippet.Transactions.send_request/1. The function receive_response/2 is called from the client transaction process when the parameter client_key is not nil, and from the transport process (possibly a poolboy worker process), when the client_key is nil.","ref":"Sippet.Core.html#c:receive_response/2","title":"Sippet.Core.receive_response/2","type":"callback"},{"doc":"Message primitive for composing SIP messages. Build a SIP message with the Sippet.Message struct. request = Sippet.Message.build_request(&quot;INVITE&quot;, &quot;sip:joe@example.com&quot;) |&gt; Sippet.Message.put_header(:to, {&quot;&quot;, Sippet.URI.parse!(&quot;sip:joe@example.com&quot;), %{}}) ...","ref":"Sippet.Message.html","title":"Sippet.Message","type":"module"},{"doc":"Returns a SIP request created from its basic elements. If the method is a binary and is a known method, it will be converted to a lowercase atom; otherwise, it will be stored as an uppercase string. If method is an atom, it will be just kept. If the request_uri is a binary, it will be parsed as a Sippet.URI struct. Otherwise, if it&#39;s already a Sippet.URI, it will be stored unmodified. The newly created struct has an empty header map, and the body is nil. Examples: iex&gt; req1 = Sippet.Message.build_request(:invite, &quot;sip:foo@bar.com&quot;) %Sippet.Message{body: nil, headers: %{}, start_line: %Sippet.Message.RequestLine{method: :invite, request_uri: %Sippet.URI{authority: &quot;foo@bar.com&quot;, headers: nil, host: &quot;bar.com&quot;, parameters: nil, port: 5060, scheme: &quot;sip&quot;, userinfo: &quot;foo&quot;}, version: {2, 0}}, target: nil} iex&gt; req2 = Sippet.Message.build_request(&quot;INVITE&quot;, &quot;sip:foo@bar.com&quot;) iex&gt; request_uri = Sippet.URI.parse!(&quot;sip:foo@bar.com&quot;) iex&gt; req3 = Sippet.Message.build_request(&quot;INVITE&quot;, request_uri) iex&gt; req1 == req2 and req2 == req3 true","ref":"Sippet.Message.html#build_request/2","title":"Sippet.Message.build_request/2","type":"function"},{"doc":"Returns a SIP response created from its basic elements. The status parameter can be a Sippet.Message.StatusLine struct or an integer in the range 100..699 representing the SIP response status code. In the latter case, a default reason phrase will be obtained from a default set; if there&#39;s none, then an exception will be raised. Examples: iex&gt; resp1 = Sippet.Message.build_response 200 %Sippet.Message{body: nil, headers: %{}, start_line: %Sippet.Message.StatusLine{reason_phrase: &quot;OK&quot;, status_code: 200, version: {2, 0}}, target: nil} iex&gt; status_line = Sippet.Message.StatusLine.new(200) iex&gt; resp2 = status_line |&gt; Sippet.Message.build_response iex&gt; resp1 == resp2 true","ref":"Sippet.Message.html#build_response/1","title":"Sippet.Message.build_response/1","type":"function"},{"doc":"Returns a SIP response with a custom reason phrase. The status_code should be an integer in the range 100..699 representing the SIP status code, and reason_phrase a binary representing the reason phrase text. iex&gt; Sippet.Message.build_response 400, &quot;Bad Lorem Ipsum&quot; %Sippet.Message{body: nil, headers: %{}, start_line: %Sippet.Message.StatusLine{reason_phrase: &quot;Bad Lorem Ipsum&quot;, status_code: 400, version: {2, 0}}, target: nil}","ref":"Sippet.Message.html#build_response/2","title":"Sippet.Message.build_response/2","type":"function"},{"doc":"Creates an unique local branch (72-bit random string, 7+12 characters long). Example: Sippet.Message.create_branch &quot;z9hG4bKuQpiub9h7fBb&quot;","ref":"Sippet.Message.html#create_branch/0","title":"Sippet.Message.create_branch/0","type":"function"},{"doc":"Creates an unique Call-ID (120-bit random string, 20 characters long). Example Sippet.create_call_id &quot;NlV4TfQwkmPlNJkyHPpF&quot;","ref":"Sippet.Message.html#create_call_id/0","title":"Sippet.Message.create_call_id/0","type":"function"},{"doc":"Creates a local tag (48-bit random string, 8 characters long). Example: Sippet.Message.create_tag &quot;lnTMo9Zn&quot;","ref":"Sippet.Message.html#create_tag/0","title":"Sippet.Message.create_tag/0","type":"function"},{"doc":"Deletes all header values in message. Examples: iex&gt; request = ...&gt; Sippet.Message.build_request(:invite, &quot;sip:foo@bar.com&quot;) ...&gt; |&gt; Sippet.Message.put_header(:content_language, [&quot;en-US&quot;, &quot;de-DE&quot;]) ...&gt; |&gt; Sippet.Message.put_header(:max_forwards, 70) iex&gt; request |&gt; Sippet.Message.delete_header(:content_language) %Sippet.Message{body: nil, headers: %{max_forwards: 70}, start_line: %Sippet.Message.RequestLine{method: :invite, request_uri: %Sippet.URI{authority: &quot;foo@bar.com&quot;, headers: nil, host: &quot;bar.com&quot;, parameters: nil, port: 5060, scheme: &quot;sip&quot;, userinfo: &quot;foo&quot;}, version: {2, 0}}, target: nil}","ref":"Sippet.Message.html#delete_header/2","title":"Sippet.Message.delete_header/2","type":"function"},{"doc":"Deletes the last value of header in message. Examples: iex&gt; request = ...&gt; Sippet.Message.build_request(:invite, &quot;sip:foo@bar.com&quot;) ...&gt; |&gt; Sippet.Message.put_header(:content_language, [&quot;en-US&quot;, &quot;de-DE&quot;]) ...&gt; |&gt; Sippet.Message.put_header(:max_forwards, 70) iex&gt; request |&gt; Sippet.Message.delete_header_back(:content_language) %Sippet.Message{body: nil, headers: %{content_language: [&quot;en-US&quot;], max_forwards: 70}, start_line: %Sippet.Message.RequestLine{method: :invite, request_uri: %Sippet.URI{authority: &quot;foo@bar.com&quot;, headers: nil, host: &quot;bar.com&quot;, parameters: nil, port: 5060, scheme: &quot;sip&quot;, userinfo: &quot;foo&quot;}, version: {2, 0}}, target: nil}","ref":"Sippet.Message.html#delete_header_back/2","title":"Sippet.Message.delete_header_back/2","type":"function"},{"doc":"Deletes the first value of header in message. Examples: iex&gt; request = ...&gt; Sippet.Message.build_request(:invite, &quot;sip:foo@bar.com&quot;) ...&gt; |&gt; Sippet.Message.put_header(:content_language, [&quot;en-US&quot;, &quot;de-DE&quot;]) ...&gt; |&gt; Sippet.Message.put_header(:max_forwards, 70) iex&gt; request |&gt; Sippet.Message.delete_header_front(:content_language) %Sippet.Message{body: nil, headers: %{content_language: [&quot;de-DE&quot;], max_forwards: 70}, start_line: %Sippet.Message.RequestLine{method: :invite, request_uri: %Sippet.URI{authority: &quot;foo@bar.com&quot;, headers: nil, host: &quot;bar.com&quot;, parameters: nil, port: 5060, scheme: &quot;sip&quot;, userinfo: &quot;foo&quot;}, version: {2, 0}}, target: nil}","ref":"Sippet.Message.html#delete_header_front/2","title":"Sippet.Message.delete_header_front/2","type":"function"},{"doc":"Drops all given headers from message. Examples: iex&gt; request = ...&gt; Sippet.Message.build_request(:invite, &quot;sip:foo@bar.com&quot;) ...&gt; |&gt; Sippet.Message.put_header(:content_language, [&quot;en-US&quot;, &quot;de-DE&quot;]) ...&gt; |&gt; Sippet.Message.put_header(:max_forwards, 70) iex&gt; request |&gt; Sippet.Message.drop_headers([:content_language, :max_forwards]) %Sippet.Message{body: nil, headers: %{}, start_line: %Sippet.Message.RequestLine{method: :invite, request_uri: %Sippet.URI{authority: &quot;foo@bar.com&quot;, headers: nil, host: &quot;bar.com&quot;, parameters: nil, port: 5060, scheme: &quot;sip&quot;, userinfo: &quot;foo&quot;}, version: {2, 0}}, target: nil}","ref":"Sippet.Message.html#drop_headers/2","title":"Sippet.Message.drop_headers/2","type":"function"},{"doc":"Fetches all values for a specific header and returns it in a tuple. If the header does not exist, returns :error. Examples: iex&gt; request = ...&gt; Sippet.Message.build_request(:invite, &quot;sip:foo@bar.com&quot;) ...&gt; |&gt; Sippet.Message.put_header(:content_language, [&quot;en-US&quot;, &quot;de-DE&quot;]) ...&gt; |&gt; Sippet.Message.put_header(:max_forwards, 70) iex&gt; request |&gt; Sippet.Message.fetch_header(:content_language) {:ok, [&quot;en-US&quot;, &quot;de-DE&quot;]} iex&gt; request |&gt; Sippet.Message.fetch_header(:cseq) :error","ref":"Sippet.Message.html#fetch_header/2","title":"Sippet.Message.fetch_header/2","type":"function"},{"doc":"Fetches all values for a specific header in the given message, erroring out if message doesn&#39;t contain header. If message contains the given header, all corresponding values are returned in a list. If message doesn&#39;t contain the header, a KeyError exception is raised.","ref":"Sippet.Message.html#fetch_header!/2","title":"Sippet.Message.fetch_header!/2","type":"function"},{"doc":"Fetches the last value of a specific header and returns it in a tuple. If the header does not exist, or the value is not a list, returns :error. If the header exists but it is an empty list, returns {:ok, nil}. Examples: iex&gt; request = ...&gt; Sippet.Message.build_request(:invite, &quot;sip:foo@bar.com&quot;) ...&gt; |&gt; Sippet.Message.put_header(:content_language, [&quot;en-US&quot;, &quot;de-DE&quot;]) ...&gt; |&gt; Sippet.Message.put_header(:max_forwards, 70) iex&gt; request |&gt; Sippet.Message.fetch_header_back(:content_language) {:ok, &quot;de-DE&quot;} iex&gt; request |&gt; Sippet.Message.fetch_header_back(:max_forwards) :error iex&gt; request |&gt; Sippet.Message.fetch_header_back(:cseq) :error","ref":"Sippet.Message.html#fetch_header_back/2","title":"Sippet.Message.fetch_header_back/2","type":"function"},{"doc":"Fetches the last value of a specific header in the given message, erroring out if message doesn&#39;t contain header. If message contains the given header, the last value is returned, which may be nil case the values list is empty. If message doesn&#39;t contain the header, a KeyError exception is raised.","ref":"Sippet.Message.html#fetch_header_back!/2","title":"Sippet.Message.fetch_header_back!/2","type":"function"},{"doc":"Fetches the first value of a specific header and returns it in a tuple. If the header does not exist, or the value is not a list, returns :error. If the header exists but it is an empty list, returns {:ok, nil}. Examples: iex&gt; request = ...&gt; Sippet.Message.build_request(:invite, &quot;sip:foo@bar.com&quot;) ...&gt; |&gt; Sippet.Message.put_header(:content_language, [&quot;en-US&quot;, &quot;de-DE&quot;]) ...&gt; |&gt; Sippet.Message.put_header(:max_forwards, 70) iex&gt; request |&gt; Sippet.Message.fetch_header_front(:content_language) {:ok, &quot;en-US&quot;} iex&gt; request |&gt; Sippet.Message.fetch_header_front(:max_forwards) :error iex&gt; request |&gt; Sippet.Message.fetch_header_front(:cseq) :error","ref":"Sippet.Message.html#fetch_header_front/2","title":"Sippet.Message.fetch_header_front/2","type":"function"},{"doc":"Fetches the first value of a specific header in the given message, erroring out if message doesn&#39;t contain header. If message contains the given header, the first value is returned, which may be nil case the values list is empty. If message doesn&#39;t contain the header, a KeyError exception is raised.","ref":"Sippet.Message.html#fetch_header_front!/2","title":"Sippet.Message.fetch_header_front!/2","type":"function"},{"doc":"Gets the values from header and updates it, all in one pass. fun is called with the current values under header in message (or nil if key is not present in message) and must return a two-element tuple: the &quot;get&quot; value (the retrieved values, which can be operated on before being returned) and the new values to be stored under header in the resulting new message. fun may also return :pop, which means all current values shall be removed from message and returned (making this function behave like Sippet.Message.pop_header(message, header). The returned value is a tuple with the &quot;get&quot; value returned by fun and a new message with the updated values under header.","ref":"Sippet.Message.html#get_and_update_header/3","title":"Sippet.Message.get_and_update_header/3","type":"function"},{"doc":"Gets the last value from header and updates it, all in one pass. fun is called with the current last value under header in message (or nil if key is not present in message) and must return a two-element tuple: the &quot;get&quot; value (the retrieved value, which can be operated on before being returned) and the new value to be stored under header in the resulting new message. fun may also return :pop, which means the current value shall be removed from message and returned (making this function behave like Sippet.Message.pop_header_back(message, header). The returned value is a tuple with the &quot;get&quot; value returned by fun and a new message with the updated values under header.","ref":"Sippet.Message.html#get_and_update_header_back/3","title":"Sippet.Message.get_and_update_header_back/3","type":"function"},{"doc":"Gets the first value from header and updates it, all in one pass. fun is called with the current first value under header in message (or nil if key is not present in message) and must return a two-element tuple: the &quot;get&quot; value (the retrieved value, which can be operated on before being returned) and the new value to be stored under header in the resulting new message. fun may also return :pop, which means the current value shall be removed from message and returned (making this function behave like Sippet.Message.pop_header_front(message, header). The returned value is a tuple with the &quot;get&quot; value returned by fun and a new message with the updated values under header.","ref":"Sippet.Message.html#get_and_update_header_front/3","title":"Sippet.Message.get_and_update_header_front/3","type":"function"},{"doc":"Gets all values for a specific header in message. If header is present in message, then all values are returned in a list. Otherwise, default is returned (which is nil unless specified otherwise).","ref":"Sippet.Message.html#get_header/3","title":"Sippet.Message.get_header/3","type":"function"},{"doc":"Gets the last value of a specific header in message. If header is present in message, then the last value is returned. Otherwise, default is returned (which is nil unless specified otherwise).","ref":"Sippet.Message.html#get_header_back/3","title":"Sippet.Message.get_header_back/3","type":"function"},{"doc":"Gets the first value of a specific header in message. If header is present in message, then the first value is returned. Otherwise, default is returned (which is nil unless specified otherwise).","ref":"Sippet.Message.html#get_header_front/3","title":"Sippet.Message.get_header_front/3","type":"function"},{"doc":"Returns whether a given header exists in the given message. Examples: iex&gt; request = ...&gt; Sippet.Message.build_request(:invite, &quot;sip:foo@bar.com&quot;) ...&gt; |&gt; Sippet.Message.put_header(:cseq, {1, :invite}) iex&gt; request |&gt; Sippet.Message.has_header?(:cseq) true","ref":"Sippet.Message.html#has_header?/2","title":"Sippet.Message.has_header?/2","type":"function"},{"doc":"Returns a list of all known methods, as a list of uppercase strings. Example: iex&gt; Sippet.Message.known_methods() [&quot;ACK&quot;, &quot;BYE&quot;, &quot;CANCEL&quot;, &quot;INFO&quot;, &quot;INVITE&quot;, &quot;MESSAGE&quot;, &quot;NOTIFY&quot;, &quot;OPTIONS&quot;, &quot;PRACK&quot;, &quot;PUBLISH&quot;, &quot;PULL&quot;, &quot;PUSH&quot;, &quot;REFER&quot;, &quot;REGISTER&quot;, &quot;STORE&quot;, &quot;SUBSCRIBE&quot;, &quot;UPDATE&quot;]","ref":"Sippet.Message.html#known_methods/0","title":"Sippet.Message.known_methods/0","type":"function"},{"doc":"Returns a list of all known transport protocols, as a list of uppercase strings. Example: iex&gt; Sippet.Message.known_protocols() [&quot;AMQP&quot;, &quot;DCCP&quot;, &quot;DTLS&quot;, &quot;SCTP&quot;, &quot;STOMP&quot;, &quot;TCP&quot;, &quot;TLS&quot;, &quot;UDP&quot;, &quot;WS&quot;, &quot;WSS&quot;]","ref":"Sippet.Message.html#known_protocols/0","title":"Sippet.Message.known_protocols/0","type":"function"},{"doc":"Returns the RFC 3261 compliance magic cookie, inserted in via-branch parameters. Example: iex&gt; Sippet.Message.magic_cookie &quot;z9hG4bK&quot;","ref":"Sippet.Message.html#magic_cookie/0","title":"Sippet.Message.magic_cookie/0","type":"function"},{"doc":"Parses a SIP message header block as received by the transport layer. In order to correctly set the message body, you have to verify the :content_length header; if it exists, it reflects the body size and you have to set it manually on the returned message.","ref":"Sippet.Message.html#parse/1","title":"Sippet.Message.parse/1","type":"function"},{"doc":"Parses a SIP message header block as received by the transport layer. Raises if the string is an invalid SIP header. In order to correctly set the message body, you have to verify the :content_length header; if it exists, it reflects the body size and you have to set it manually on the returned message.","ref":"Sippet.Message.html#parse!/1","title":"Sippet.Message.parse!/1","type":"function"},{"doc":"Returns and removes the values associated with header in message. If header is present in message with values [value], {[value], new_message} is returned where new_message is the result of removing header from message. If header is not present in message, {default, message} is returned.","ref":"Sippet.Message.html#pop_header/3","title":"Sippet.Message.pop_header/3","type":"function"},{"doc":"Returns and removes the last value associated with header in message. If header is present in message with values values, {List.last(values), new_message} is returned where new_message is the result of removing List.last(values) from header. If header is not present in message or it is an empty list, {default, message} is returned. When the header results in an empty list, message gets updated by removing the header.","ref":"Sippet.Message.html#pop_header_back/3","title":"Sippet.Message.pop_header_back/3","type":"function"},{"doc":"Returns and removes the first value associated with header in message. If header is present in message with values values, {List.first(values), new_message} is returned where new_message is the result of removing List.first(values) from header. If header is not present in message or it is an empty list, {default, message} is returned. When the header results in an empty list, message gets updated by removing the header.","ref":"Sippet.Message.html#pop_header_front/3","title":"Sippet.Message.pop_header_front/3","type":"function"},{"doc":"Puts the value under header on the message. If the header already exists, it will be overridden. Examples: iex&gt; request = Sippet.Message.build_request(:invite, &quot;sip:foo@bar.com&quot;) iex&gt; request |&gt; Sippet.Message.put_header(:cseq, {1, :invite}) %Sippet.Message{body: nil, headers: %{cseq: {1, :invite}}, start_line: %Sippet.Message.RequestLine{method: :invite, request_uri: %Sippet.URI{authority: &quot;foo@bar.com&quot;, headers: nil, host: &quot;bar.com&quot;, parameters: nil, port: 5060, scheme: &quot;sip&quot;, userinfo: &quot;foo&quot;}, version: {2, 0}}, target: nil}","ref":"Sippet.Message.html#put_header/3","title":"Sippet.Message.put_header/3","type":"function"},{"doc":"Puts the value under header on the message, as last element. If the parameter value is nil, then the empty list will be appended to the header. Examples: iex&gt; Sippet.Message.build_request(:invite, &quot;sip:foo@bar.com&quot;) ...&gt; |&gt; Sippet.Message.put_header_back(:content_language, &quot;en-US&quot;) ...&gt; |&gt; Sippet.Message.put_header_back(:content_language, &quot;de-DE&quot;) %Sippet.Message{body: nil, headers: %{content_language: [&quot;en-US&quot;, &quot;de-DE&quot;]}, start_line: %Sippet.Message.RequestLine{method: :invite, request_uri: %Sippet.URI{authority: &quot;foo@bar.com&quot;, headers: nil, host: &quot;bar.com&quot;, parameters: nil, port: 5060, scheme: &quot;sip&quot;, userinfo: &quot;foo&quot;}, version: {2, 0}}, target: nil}","ref":"Sippet.Message.html#put_header_back/3","title":"Sippet.Message.put_header_back/3","type":"function"},{"doc":"Puts the value under header on the message, as front element. If the parameter value is nil, then the empty list will be prefixed to the header. Examples: iex&gt; Sippet.Message.build_request(:invite, &quot;sip:foo@bar.com&quot;) ...&gt; |&gt; Sippet.Message.put_header_front(:content_language, &quot;de-DE&quot;) ...&gt; |&gt; Sippet.Message.put_header_front(:content_language, &quot;en-US&quot;) %Sippet.Message{body: nil, headers: %{content_language: [&quot;en-US&quot;, &quot;de-DE&quot;]}, start_line: %Sippet.Message.RequestLine{method: :invite, request_uri: %Sippet.URI{authority: &quot;foo@bar.com&quot;, headers: nil, host: &quot;bar.com&quot;, parameters: nil, port: 5060, scheme: &quot;sip&quot;, userinfo: &quot;foo&quot;}, version: {2, 0}}, target: nil}","ref":"Sippet.Message.html#put_header_front/3","title":"Sippet.Message.put_header_front/3","type":"function"},{"doc":"Puts the value under header on the message unless the header already exists. Examples: iex&gt; Sippet.Message.build_request(:invite, &quot;sip:foo@bar.com&quot;) ...&gt; |&gt; Sippet.Message.put_new_header(:max_forwards, 70) ...&gt; |&gt; Sippet.Message.put_new_header(:max_forwards, 1) %Sippet.Message{body: nil, headers: %{max_forwards: 70}, start_line: %Sippet.Message.RequestLine{method: :invite, request_uri: %Sippet.URI{authority: &quot;foo@bar.com&quot;, headers: nil, host: &quot;bar.com&quot;, parameters: nil, port: 5060, scheme: &quot;sip&quot;, userinfo: &quot;foo&quot;}, version: {2, 0}}, target: nil}","ref":"Sippet.Message.html#put_new_header/3","title":"Sippet.Message.put_new_header/3","type":"function"},{"doc":"Evaluates fun and puts the result under header in message unless header is already present. This function is useful in case you want to compute the value to put under header only if header is not already present (e.g., the value is expensive to calculate or generally difficult to setup and teardown again). Examples: iex&gt; Sippet.Message.build_request(:invite, &quot;sip:foo@bar.com&quot;) ...&gt; |&gt; Sippet.Message.put_new_lazy_header(:max_forwards, fn -&gt; 70 end) ...&gt; |&gt; Sippet.Message.put_new_lazy_header(:max_forwards, fn -&gt; 1 end) %Sippet.Message{body: nil, headers: %{max_forwards: 70}, start_line: %Sippet.Message.RequestLine{method: :invite, request_uri: %Sippet.URI{authority: &quot;foo@bar.com&quot;, headers: nil, host: &quot;bar.com&quot;, parameters: nil, port: 5060, scheme: &quot;sip&quot;, userinfo: &quot;foo&quot;}, version: {2, 0}}, target: nil}","ref":"Sippet.Message.html#put_new_lazy_header/3","title":"Sippet.Message.put_new_lazy_header/3","type":"function"},{"doc":"Shortcut to check if the message is a request. Examples: iex&gt; req = Sippet.Message.build_request :invite, &quot;sip:foo@bar.com&quot; iex&gt; req |&gt; Sippet.Message.request? true","ref":"Sippet.Message.html#request?/1","title":"Sippet.Message.request?/1","type":"function"},{"doc":"Shortcut to check if the message is a response. Examples: iex&gt; resp = Sippet.Message.build_response 200 iex&gt; resp |&gt; Sippet.Message.response? true","ref":"Sippet.Message.html#response?/1","title":"Sippet.Message.response?/1","type":"function"},{"doc":"Returns the iodata representation of the given Sippet.Message struct.","ref":"Sippet.Message.html#to_iodata/1","title":"Sippet.Message.to_iodata/1","type":"function"},{"doc":"Converts a string representing a known method into an atom, otherwise as an uppercase string. Example: iex&gt; Sippet.Message.to_method(&quot;INVITE&quot;) :invite iex&gt; Sippet.Message.to_method(&quot;InViTe&quot;) :invite iex&gt; Sippet.Message.to_method(&quot;aaa&quot;) &quot;AAA&quot;","ref":"Sippet.Message.html#to_method/1","title":"Sippet.Message.to_method/1","type":"function"},{"doc":"Converts a string representing a known protocol into an atom, otherwise as an uppercase string. Example: iex&gt; Sippet.Message.to_protocol(&quot;UDP&quot;) :udp iex&gt; Sippet.Message.to_protocol(&quot;uDp&quot;) :udp iex&gt; Sippet.Message.to_protocol(&quot;aaa&quot;) &quot;AAA&quot;","ref":"Sippet.Message.html#to_protocol/1","title":"Sippet.Message.to_protocol/1","type":"function"},{"doc":"Returns a response created from a request, using a given status code. The request should be a valid SIP request, or an exception will be thrown. The status parameter can be a Sippet.Message.StatusLine struct or an integer in the range 100..699 representing the SIP response status code. In the latter case, a default reason phrase will be obtained from a default set; if there&#39;s none, then an exception will be raised. Example: request = &quot;&quot;&quot; REGISTER sips:ss2.biloxi.example.com SIP/2.0 Via: SIP/2.0/TLS client.biloxi.example.com:5061;branch=z9hG4bKnashds7 Max-Forwards: 70 From: Bob &lt;sips:bob@biloxi.example.com&gt;;tag=a73kszlfl To: Bob &lt;sips:bob@biloxi.example.com&gt; Call-ID: 1j9FpLxk3uxtm8tn@biloxi.example.com CSeq: 1 REGISTER Contact: &lt;sips:bob@client.biloxi.example.com&gt; Content-Length: 0 &quot;&quot;&quot; |&gt; Sippet.Message.parse!() request |&gt; Sippet.Message.to_response(200) |&gt; IO.puts SIP/2.0 200 OK Via: SIP/2.0/TLS client.biloxi.example.com:5061;branch=z9hG4bKnashds7 To: &quot;Bob&quot; &lt;sips:bob@biloxi.example.com&gt;;tag=K2fizKkV From: &quot;Bob&quot; &lt;sips:bob@biloxi.example.com&gt;;tag=a73kszlfl CSeq: 1 REGISTER Content-Length: 0 Call-ID: 1j9FpLxk3uxtm8tn@biloxi.example.com :ok","ref":"Sippet.Message.html#to_response/2","title":"Sippet.Message.to_response/2","type":"function"},{"doc":"Returns a response created from a request, using a given status code and a custom reason phrase. The request should be a valid SIP request, or an exception will be thrown. The status_code parameter should be an integer in the range 100..699 representing the SIP response status code. A default reason phrase will be obtained from a default set; if there&#39;s none, then an exception will be raised. The reason_phrase can be any textual representation of the reason phrase the application needs to generate, in binary. Example: request = &quot;&quot;&quot; REGISTER sips:ss2.biloxi.example.com SIP/2.0 Via: SIP/2.0/TLS client.biloxi.example.com:5061;branch=z9hG4bKnashds7 Max-Forwards: 70 From: Bob &lt;sips:bob@biloxi.example.com&gt;;tag=a73kszlfl To: Bob &lt;sips:bob@biloxi.example.com&gt; Call-ID: 1j9FpLxk3uxtm8tn@biloxi.example.com CSeq: 1 REGISTER Contact: &lt;sips:bob@client.biloxi.example.com&gt; Content-Length: 0 &quot;&quot;&quot; |&gt; Sippet.Message.parse!() request |&gt; Sippet.Message.to_response(400, &quot;Bad Lorem Ipsum&quot;) |&gt; IO.puts SIP/2.0 400 Bad Lorem Ipsum Via: SIP/2.0/TLS client.biloxi.example.com:5061;branch=z9hG4bKnashds7 To: &quot;Bob&quot; &lt;sips:bob@biloxi.example.com&gt;;tag=K2fizKkV From: &quot;Bob&quot; &lt;sips:bob@biloxi.example.com&gt;;tag=a73kszlfl CSeq: 1 REGISTER Content-Length: 0 Call-ID: 1j9FpLxk3uxtm8tn@biloxi.example.com :ok","ref":"Sippet.Message.html#to_response/3","title":"Sippet.Message.to_response/3","type":"function"},{"doc":"Returns the string representation of the given Sippet.Message struct.","ref":"Sippet.Message.html#to_string/1","title":"Sippet.Message.to_string/1","type":"function"},{"doc":"Updates the header in message with the given function. If header is present in message with value value, fun is invoked with argument value and its result is used as the new value of header. If header is not present in message, initial is inserted as the value of header.","ref":"Sippet.Message.html#update_header/4","title":"Sippet.Message.update_header/4","type":"function"},{"doc":"Updates the last header value in message with the given function. If header is present in message with value [value], fun is invoked with for last element of [value] and its result is used as the new value of header back. If header is not present in message, or it is an empty list, initial is inserted as the single value of header.","ref":"Sippet.Message.html#update_header_back/4","title":"Sippet.Message.update_header_back/4","type":"function"},{"doc":"Updates the first header value in message with the given function. If header is present in message with value [value], fun is invoked with for first element of [value] and its result is used as the new value of header front. If header is not present in message, or it is an empty list, initial is inserted as the single value of header.","ref":"Sippet.Message.html#update_header_front/4","title":"Sippet.Message.update_header_front/4","type":"function"},{"doc":"Checks whether a message is valid.","ref":"Sippet.Message.html#valid?/1","title":"Sippet.Message.valid?/1","type":"function"},{"doc":"Checks whether a message is valid, also checking if it corresponds to the indicated incoming transport tuple {protocol, host, port}.","ref":"Sippet.Message.html#valid?/2","title":"Sippet.Message.valid?/2","type":"function"},{"doc":"Validates if a message is valid, returning errors if found.","ref":"Sippet.Message.html#validate/1","title":"Sippet.Message.validate/1","type":"function"},{"doc":"Validates if a message is valid, also checking if it corresponds to the indicated incoming transport tuple {protocol, host, port}. It returns the error if found.","ref":"Sippet.Message.html#validate/2","title":"Sippet.Message.validate/2","type":"function"},{"doc":"","ref":"Sippet.Message.html#t:auth_params/0","title":"Sippet.Message.auth_params/0","type":"type"},{"doc":"","ref":"Sippet.Message.html#t:header/0","title":"Sippet.Message.header/0","type":"type"},{"doc":"","ref":"Sippet.Message.html#t:headers/0","title":"Sippet.Message.headers/0","type":"type"},{"doc":"","ref":"Sippet.Message.html#t:method/0","title":"Sippet.Message.method/0","type":"type"},{"doc":"","ref":"Sippet.Message.html#t:multiple_value/0","title":"Sippet.Message.multiple_value/0","type":"type"},{"doc":"","ref":"Sippet.Message.html#t:name_uri_params/0","title":"Sippet.Message.name_uri_params/0","type":"type"},{"doc":"","ref":"Sippet.Message.html#t:params/0","title":"Sippet.Message.params/0","type":"type"},{"doc":"","ref":"Sippet.Message.html#t:protocol/0","title":"Sippet.Message.protocol/0","type":"type"},{"doc":"","ref":"Sippet.Message.html#t:request/0","title":"Sippet.Message.request/0","type":"type"},{"doc":"","ref":"Sippet.Message.html#t:response/0","title":"Sippet.Message.response/0","type":"type"},{"doc":"","ref":"Sippet.Message.html#t:single_value/0","title":"Sippet.Message.single_value/0","type":"type"},{"doc":"","ref":"Sippet.Message.html#t:t/0","title":"Sippet.Message.t/0","type":"type"},{"doc":"","ref":"Sippet.Message.html#t:token/0","title":"Sippet.Message.token/0","type":"type"},{"doc":"","ref":"Sippet.Message.html#t:token_params/0","title":"Sippet.Message.token_params/0","type":"type"},{"doc":"","ref":"Sippet.Message.html#t:type_subtype_params/0","title":"Sippet.Message.type_subtype_params/0","type":"type"},{"doc":"","ref":"Sippet.Message.html#t:uri/0","title":"Sippet.Message.uri/0","type":"type"},{"doc":"","ref":"Sippet.Message.html#t:uri_params/0","title":"Sippet.Message.uri_params/0","type":"type"},{"doc":"","ref":"Sippet.Message.html#t:value/0","title":"Sippet.Message.value/0","type":"type"},{"doc":"","ref":"Sippet.Message.html#t:via_value/0","title":"Sippet.Message.via_value/0","type":"type"},{"doc":"A SIP Request-Line struct, composed by the Method, Request-URI and SIP-Version. The start_line of requests are represented by this struct. The RFC 3261 represents the Request-Line as: Request-Line = Method SP Request-URI SP SIP-Version CRLF The above Method is represented by atoms, when the method is a known one, or by binaries, when the method is unknown. Known ones are :ack, :invite, :register, :cancel, :message and all others returned by the function Sippet.Message.known_methods/0. The Request-URI is represented by a Sippet.URI struct, breaking down the SIP-URI in more useful parts for processing. The SIP-Version is a {major, minor} tuple, which assumes the value {2, 0} in standard implementations.","ref":"Sippet.Message.RequestLine.html","title":"Sippet.Message.RequestLine","type":"module"},{"doc":"Creates a Request-Line struct. The version will assume the default value {2, 0}.","ref":"Sippet.Message.RequestLine.html#new/2","title":"Sippet.Message.RequestLine.new/2","type":"function"},{"doc":"Returns an iodata which corresponds to the text representation of the given Request-Line. It does not includes an ending line CRLF.","ref":"Sippet.Message.RequestLine.html#to_iodata/1","title":"Sippet.Message.RequestLine.to_iodata/1","type":"function"},{"doc":"Returns a binary which corresponds to the text representation of the given Request-Line. It does not includes an ending line CRLF.","ref":"Sippet.Message.RequestLine.html#to_string/1","title":"Sippet.Message.RequestLine.to_string/1","type":"function"},{"doc":"","ref":"Sippet.Message.RequestLine.html#t:method/0","title":"Sippet.Message.RequestLine.method/0","type":"type"},{"doc":"","ref":"Sippet.Message.RequestLine.html#t:t/0","title":"Sippet.Message.RequestLine.t/0","type":"type"},{"doc":"","ref":"Sippet.Message.RequestLine.html#t:uri/0","title":"Sippet.Message.RequestLine.uri/0","type":"type"},{"doc":"","ref":"Sippet.Message.RequestLine.html#t:version/0","title":"Sippet.Message.RequestLine.version/0","type":"type"},{"doc":"A SIP Status-Line struct, composed by the SIP-Version, Status-Code and the Reason-Phrase. The start_line of responses are represented by this struct. The RFC 3261 represents the Status-Line as: Status-Line = SIP-Version SP Status-Code SP Reason-Phrase CRLF The above SIP-Version is represented by a {major, minor} tuple, which assumes the value {2, 0} in standard implementations. The Status-Code is a 3-digit integer in the interval 100-699 indicating the outcome of an attempt to understand and satisfy a request. The Reason-Phrase is a binary representing a short textual description of the Status-Code. The Status-Code is intended for use by automata, whereas the Reason-Phrase is intended for the human user.","ref":"Sippet.Message.StatusLine.html","title":"Sippet.Message.StatusLine","type":"module"},{"doc":"Returns a binary representing the default reason phrase for the given status_code. If the status_code does not have a corresponding default reason phrase, returns nil. Examples iex&gt; Sippet.Message.StatusLine.default_reason(202) &quot;Accepted&quot; iex&gt; Sippet.Message.StatusLine.default_reason(499) nil","ref":"Sippet.Message.StatusLine.html#default_reason/1","title":"Sippet.Message.StatusLine.default_reason/1","type":"function"},{"doc":"Returns a binary representing the default reason phrase for the given status_code. If the status_code does not have a corresponding default reason phrase, throws an exception. Examples iex&gt; Sippet.Message.StatusLine.default_reason!(202) &quot;Accepted&quot; iex&gt; Sippet.Message.StatusLine.default_reason!(499) ** (ArgumentError) status code 499 does not have a default reason phrase","ref":"Sippet.Message.StatusLine.html#default_reason!/1","title":"Sippet.Message.StatusLine.default_reason!/1","type":"function"},{"doc":"Returns a Status-Line struct. The reason_phrase is obtained from default values. The function will throw an exception if the status_code is not in the valid range 100..699 or if the status_code does not have a default reason phrase. The version will assume the default value {2, 0}. Examples iex&gt; Sippet.Message.StatusLine.new(400) %Sippet.Message.StatusLine{reason_phrase: &quot;Bad Request&quot;, status_code: 400, version: {2, 0}}","ref":"Sippet.Message.StatusLine.html#new/1","title":"Sippet.Message.StatusLine.new/1","type":"function"},{"doc":"Creates a Status-Line struct using a given reason phrase. In this function, the reason_phrase can be anything the application wants. The function will throw an exception if the status_code is not in the valid range 100..699. The version will assume the default value {2, 0}. Examples iex&gt; Sippet.Message.StatusLine.new(499, &quot;Foobar&quot;) %Sippet.Message.StatusLine{reason_phrase: &quot;Foobar&quot;, status_code: 499, version: {2, 0}}","ref":"Sippet.Message.StatusLine.html#new/2","title":"Sippet.Message.StatusLine.new/2","type":"function"},{"doc":"Returns an integer representing the status code class in the range [1, 6]. Examples iex&gt; alias Sippet.Message.StatusLine iex&gt; StatusLine.new(202) |&gt; StatusLine.status_code_class() 2","ref":"Sippet.Message.StatusLine.html#status_code_class/1","title":"Sippet.Message.StatusLine.status_code_class/1","type":"function"},{"doc":"Returns an iodata which corresponds to the text representation of the given Status-Line. It does not includes an ending line CRLF. Examples iex&gt; alias Sippet.StatusLine iex&gt; StatusLine.new(202) |&gt; StatusLine.to_iodata [&quot;SIP/&quot;, &quot;2&quot;, &quot;.&quot;, &quot;0&quot;, &quot; &quot;, &quot;202&quot;, &quot; &quot;, &quot;Accepted&quot;]","ref":"Sippet.Message.StatusLine.html#to_iodata/1","title":"Sippet.Message.StatusLine.to_iodata/1","type":"function"},{"doc":"Returns a binary which corresponds to the text representation of the given Status-Line. It does not includes an ending line CRLF. Examples iex&gt; alias Sippet.StatusLine iex&gt; StatusLine.new(202) |&gt; StatusLine.to_string &quot;SIP/2.0 202 Accepted&quot;","ref":"Sippet.Message.StatusLine.html#to_string/1","title":"Sippet.Message.StatusLine.to_string/1","type":"function"},{"doc":"","ref":"Sippet.Message.StatusLine.html#t:status_code/0","title":"Sippet.Message.StatusLine.status_code/0","type":"type"},{"doc":"","ref":"Sippet.Message.StatusLine.html#t:t/0","title":"Sippet.Message.StatusLine.t/0","type":"type"},{"doc":"","ref":"Sippet.Message.StatusLine.html#t:version/0","title":"Sippet.Message.StatusLine.version/0","type":"type"},{"doc":"Communicates with the C++ NIF parser in order to parse the SIP header. The C++ NIF module was created to optimize the parsing.","ref":"Sippet.Parser.html","title":"Sippet.Parser","type":"module"},{"doc":"Initializes and loads the C++ NIF module.","ref":"Sippet.Parser.html#init/0","title":"Sippet.Parser.init/0","type":"function"},{"doc":"Parses the SIP message into an Erlang-like map. The Sippet.Message module translates the result into an Elixir-like struct.","ref":"Sippet.Parser.html#parse/1","title":"Sippet.Parser.parse/1","type":"function"},{"doc":"Defines a key in which client transactions are uniquely identified.","ref":"Sippet.Transactions.Client.Key.html","title":"Sippet.Transactions.Client.Key","type":"module"},{"doc":"Create a client transaction identifier from an outgoing request or an incoming response. If they are related, they will be equal.","ref":"Sippet.Transactions.Client.Key.html#new/1","title":"Sippet.Transactions.Client.Key.new/1","type":"function"},{"doc":"Create a client transaction identifier.","ref":"Sippet.Transactions.Client.Key.html#new/2","title":"Sippet.Transactions.Client.Key.new/2","type":"function"},{"doc":"The topmost Via header branch parameter","ref":"Sippet.Transactions.Client.Key.html#t:branch/0","title":"Sippet.Transactions.Client.Key.branch/0","type":"type"},{"doc":"","ref":"Sippet.Transactions.Client.Key.html#t:t/0","title":"Sippet.Transactions.Client.Key.t/0","type":"type"},{"doc":"Defines a key in which server transactions are uniquely identified.","ref":"Sippet.Transactions.Server.Key.html","title":"Sippet.Transactions.Server.Key","type":"module"},{"doc":"Creates a server transaction identifier from an incoming request or an outgoing response. If they are related, they will be equal.","ref":"Sippet.Transactions.Server.Key.html#new/1","title":"Sippet.Transactions.Server.Key.new/1","type":"function"},{"doc":"Creates a server transaction identifier.","ref":"Sippet.Transactions.Server.Key.html#new/3","title":"Sippet.Transactions.Server.Key.new/3","type":"function"},{"doc":"The topmost Via header branch parameter","ref":"Sippet.Transactions.Server.Key.html#t:branch/0","title":"Sippet.Transactions.Server.Key.branch/0","type":"type"},{"doc":"The topmost Via header sent-by parameter","ref":"Sippet.Transactions.Server.Key.html#t:sentby/0","title":"Sippet.Transactions.Server.Key.sentby/0","type":"type"},{"doc":"","ref":"Sippet.Transactions.Server.Key.html#t:t/0","title":"Sippet.Transactions.Server.Key.t/0","type":"type"},{"doc":"Implements an UDP transport. The UDP transport consists basically in a single listening and sending process, this implementation itself. This process creates an UDP socket and keeps listening for datagrams in active mode. Its job is to forward the datagrams to the processing receiver defined in Sippet.Transports.Receiver.","ref":"Sippet.Transports.UDP.html","title":"Sippet.Transports.UDP","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"Sippet.Transports.UDP.html#child_spec/1","title":"Sippet.Transports.UDP.child_spec/1","type":"function"},{"doc":"Starts the UDP transport.","ref":"Sippet.Transports.UDP.html#start_link/1","title":"Sippet.Transports.UDP.start_link/1","type":"function"},{"doc":"Utilities for working with SIP-URIs. This module provides functions for working with URIs (for example, parsing SIP-URIs, encoding parameters or header strings).","ref":"Sippet.URI.html","title":"Sippet.URI","type":"module"},{"doc":"Checks if the character is an &quot;hnv-unreserved&quot; character in a SIP-URI. Examples iex&gt; Sippet.URI.char_hnv_unreserved?(?:) true","ref":"Sippet.URI.html#char_hnv_unreserved?/1","title":"Sippet.URI.char_hnv_unreserved?/1","type":"function"},{"doc":"Checks if the character is an &quot;param-unreserved&quot; character in a SIP-URI. Examples iex&gt; Sippet.URI.char_param_unreserved?(?~) false","ref":"Sippet.URI.html#char_param_unreserved?/1","title":"Sippet.URI.char_param_unreserved?/1","type":"function"},{"doc":"Checks if the character is an &quot;unreserved&quot; character in a SIP-URI. Examples iex&gt; Sippet.URI.char_unreserved?(?~) true","ref":"Sippet.URI.html#char_unreserved?/1","title":"Sippet.URI.char_unreserved?/1","type":"function"},{"doc":"Decodes a &quot;headers&quot; string into a map. Given a &quot;headers&quot; string of the form of ?key1=value1&amp;key2=value2..., this function inserts each key-value pair in the query string as one entry in the given map. Keys and values in the resulting map will be binaries. Keys and values will be percent-unescaped. Use headers_decoder/1 if you want to iterate over each value manually. Examples iex&gt; Sippet.URI.decode_headers(&quot;?foo=1&amp;bar=2&quot;) %{&quot;bar&quot; =&gt; &quot;2&quot;, &quot;foo&quot; =&gt; &quot;1&quot;}","ref":"Sippet.URI.html#decode_headers/2","title":"Sippet.URI.decode_headers/2","type":"function"},{"doc":"Decodes a &quot;uri-parameters&quot; string into a map. Given a &quot;uri-parameters&quot; string of the form of ;key1=value1;key2=value2..., this function inserts each key-value pair in the query string as one entry in the given map. Keys and values in the resulting map will be binaries. Keys and values will be percent-unescaped. Use parameters_decoder/1 if you want to iterate over each value manually. Examples iex&gt; Sippet.URI.decode_parameters(&quot;;foo=1;bar=2&quot;) %{&quot;bar&quot; =&gt; &quot;2&quot;, &quot;foo&quot; =&gt; &quot;1&quot;}","ref":"Sippet.URI.html#decode_parameters/2","title":"Sippet.URI.decode_parameters/2","type":"function"},{"doc":"Returns the default port for a given SIP scheme. If the scheme is unknown to the Sippet.URI module, this function returns nil. Examples iex&gt; Sippet.URI.default_port(&quot;sip&quot;) 5060 iex&gt; Sippet.URI.default_port(&quot;ponzi&quot;) nil","ref":"Sippet.URI.html#default_port/1","title":"Sippet.URI.default_port/1","type":"function"},{"doc":"Encodes an enumerable into a &quot;headers&quot; string. Takes an enumerable that enumerates as a list of two-element tuples (e.g., a map or a keyword list) and returns a string in the form of ?key1=value1&amp;key2=value2... where keys and values are encoded as per encode_header/1. Keys and values can be any term that implements the String.Chars protocol, except lists which are explicitly forbidden. Examples iex&gt; hd = %{&quot;foo&quot; =&gt; 1, &quot;bar&quot; =&gt; 2} iex&gt; Sippet.URI.encode_headers(hd) &quot;?bar=2&amp;foo=1&quot; iex&gt; headers = %{&quot;key&quot; =&gt; &quot;value with spaces&quot;} iex&gt; Sippet.URI.encode_headers(headers) &quot;?key=value%20with%20spaces&quot; iex&gt; Sippet.URI.encode_headers %{key: [:a, :list]} ** (ArgumentError) encode_headers/1 values cannot be lists, got: [:a, :list]","ref":"Sippet.URI.html#encode_headers/1","title":"Sippet.URI.encode_headers/1","type":"function"},{"doc":"Encodes a string as &quot;hname&quot; / &quot;hvalue&quot;. Example iex&gt; Sippet.URI.encode_hnvchar(&quot;put: it+й&quot;) &quot;put:%20it+%D0%B9&quot;","ref":"Sippet.URI.html#encode_hnvchar/1","title":"Sippet.URI.encode_hnvchar/1","type":"function"},{"doc":"Encodes a string as &quot;paramchar&quot;. Example iex&gt; Sippet.URI.encode_paramchar(&quot;put: it+й&quot;) &quot;put:%20it+%D0%B9&quot;","ref":"Sippet.URI.html#encode_paramchar/1","title":"Sippet.URI.encode_paramchar/1","type":"function"},{"doc":"Encodes an enumerable into a &quot;uri-parameters&quot; string. Takes an enumerable that enumerates as a list of two-element tuples (e.g., a map or a keyword list) and returns a string in the form of ;key1=value1;key2=value2... where keys and values are encoded as per encode_paramchar/1. Keys and values can be any term that implements the String.Chars protocol, except lists which are explicitly forbidden. Examples iex&gt; hd = %{&quot;foo&quot; =&gt; 1, &quot;bar&quot; =&gt; 2} iex&gt; Sippet.URI.encode_parameters(hd) &quot;;bar=2;foo=1&quot; iex&gt; parameters = %{&quot;key&quot; =&gt; &quot;value with spaces&quot;} iex&gt; Sippet.URI.encode_parameters(parameters) &quot;;key=value%20with%20spaces&quot; iex&gt; Sippet.URI.encode_parameters %{key: [:a, :list]} ** (ArgumentError) encode_parameters/1 values cannot be lists, got: [:a, :list]","ref":"Sippet.URI.html#encode_parameters/1","title":"Sippet.URI.encode_parameters/1","type":"function"},{"doc":"Checks whether two SIP-URIs are equivalent. This function follows the RFC 3261 rules specified in section 19.1.4. Examples iex&gt; a = Sippet.URI.parse!(&quot;sip:%61lice@atlanta.com;transport=TCP&quot;) iex&gt; b = Sippet.URI.parse!(&quot;sip:alice@atlanta.com;transport=tcp&quot;) iex&gt; Sippet.URI.equivalent(a, b) true","ref":"Sippet.URI.html#equivalent/2","title":"Sippet.URI.equivalent/2","type":"function"},{"doc":"Returns a stream of two-element tuples representing key-value pairs in the given headers. Key and value in each tuple will be binaries and will be percent-unescaped. Examples iex&gt; Sippet.URI.headers_decoder(&quot;?foo=1&amp;bar=2&quot;) |&gt; Enum.to_list() [{&quot;foo&quot;, &quot;1&quot;}, {&quot;bar&quot;, &quot;2&quot;}]","ref":"Sippet.URI.html#headers_decoder/1","title":"Sippet.URI.headers_decoder/1","type":"function"},{"doc":"Checks whether two SIP-URIs are equivalent, but using more lazy rules. Examples iex&gt; a = Sippet.URI.parse!(&quot;sip:atlanta.com;transport=UDP&quot;) iex&gt; b = Sippet.URI.parse!(&quot;sip:atlanta.com:5060&quot;) iex&gt; Sippet.URI.lazy_equivalent(a, b) true","ref":"Sippet.URI.html#lazy_equivalent/2","title":"Sippet.URI.lazy_equivalent/2","type":"function"},{"doc":"Returns a stream of two-element tuples representing key-value pairs in the given parameters. Key and value in each tuple will be binaries and will be percent-unescaped. Examples iex&gt; Sippet.URI.parameters_decoder(&quot;;foo=1;bar=2&quot;) |&gt; Enum.to_list() [{&quot;foo&quot;, &quot;1&quot;}, {&quot;bar&quot;, &quot;2&quot;}]","ref":"Sippet.URI.html#parameters_decoder/1","title":"Sippet.URI.parameters_decoder/1","type":"function"},{"doc":"Parses a well-formed SIP-URI reference into its components. Note this function expects a well-formed SIP-URI and does not perform any validation. See the &quot;Examples&quot; section below for examples of how Sippet.URI.parse/1 can be used to parse a wide range of URIs. When a SIP-URI is given without a port, the value returned by Sippet.URI.default_port/1 for the SIP-URI&#39;s scheme is used for the :port field. If a %Sippet.URI{} struct is given to this function, this function returns it unmodified. Examples iex&gt; Sippet.URI.parse(&quot;sip:user@host?Call-Info=%3Chttp://www.foo.com%3E&amp;Subject=foo&quot;) {:ok, %Sippet.URI{scheme: &quot;sip&quot;, userinfo: &quot;user&quot;, authority: &quot;user@host&quot;, host: &quot;host&quot;, port: 5060, parameters: nil, headers: &quot;?Call-Info=%3Chttp://www.foo.com%3E&amp;Subject=foo&quot;}} iex&gt; Sippet.URI.parse(&quot;sip:user@host;transport=FOO&quot;) {:ok, %Sippet.URI{scheme: &quot;sip&quot;, userinfo: &quot;user&quot;, authority: &quot;user@host&quot;, host: &quot;host&quot;, port: 5060, parameters: &quot;;transport=FOO&quot;, headers: nil}} iex&gt; Sippet.URI.parse(&quot;sip:user@host&quot;) {:ok, %Sippet.URI{scheme: &quot;sip&quot;, userinfo: &quot;user&quot;, authority: &quot;user@host&quot;, host: &quot;host&quot;, port: 5060, parameters: nil, headers: nil}}","ref":"Sippet.URI.html#parse/1","title":"Sippet.URI.parse/1","type":"function"},{"doc":"Parses a well-formed SIP-URI reference into its components. If invalid, raises an exception.","ref":"Sippet.URI.html#parse!/1","title":"Sippet.URI.parse!/1","type":"function"},{"doc":"Decodes an encoded string, transforming any percent encoding back to corresponding characters. Examples iex&gt; Sippet.URI.percent_unescape(&quot;%3Call%20in%2F&quot;) &quot;&lt;all in/&quot;","ref":"Sippet.URI.html#percent_unescape/1","title":"Sippet.URI.percent_unescape/1","type":"function"},{"doc":"Returns the string representation of the given Sippet.URI struct. Examples iex&gt; Sippet.URI.to_string(Sippet.URI.parse!(&quot;sip:foo@bar.com&quot;)) &quot;sip:foo@bar.com&quot; iex&gt; Sippet.URI.to_string(%URI{scheme: &quot;foo&quot;, host: &quot;bar.baz&quot;}) &quot;foo:bar.baz&quot;","ref":"Sippet.URI.html#to_string/1","title":"Sippet.URI.to_string/1","type":"function"},{"doc":"","ref":"Sippet.URI.html#t:t/0","title":"Sippet.URI.t/0","type":"type"}]